#!/usr/local/bin/python

import tkSimpleDialog, string, os.path
from Tkinter import *

import strings
strings = strings.messages


pronunciation = {
    "AA": "odd  AA D, father F AA DH ER",
    "AE": "at        AE T",
    "AH": "hut        HH AH T",
    "AO": "ought  AO T  hot dog HH AA T D AO G",
    "AW": "cow        K AW",
    "AY": "hide        HH AY D",
    "B": "be        B IY",
    "CH": "cheese        CH IY Z",
    "D": "dee        D IY",
    "DH": "thee        DH IY",
    "EH": "Ed        EH D",
    "ER": "hurt        HH ER T",
    "EY": "ate        EY T",
    "F": "fee        F IY",
    "G": "green        G R IY N",
    "HH": "he        HH IY",
    "IH": "it        IH T",
    "IY": "eat        IY T",
    "JH": "gee        JH IY",
    "K": "key        K IY",
    "L": "lee        L IY",
    "M": "me        M IY",
    "N": "knee        N IY",
    "NG": "ping        P IY NG",
    "OW": "oat        OW T",
    "OY": "toy        T OY",
    "P": "pee        P IY",
    "R": "read        R IY D",
    "S": "sea        S IY",
    "SH": "she        SH IY",
    "T": "tea        T IY",
    "TH": "theta        TH EY T AH",
    "UH": "hood        HH UH D",
    "UW": "two        T UW",
    "V": "vee        V IY",
    "W": "we        W IY",
    "Y": "yield        Y IY L D",
    "Z": "zee        Z IY",
    "ZH": "seizure        S IY ZH ER",
}


class breakdownDialog(tkSimpleDialog.Dialog):
# class breakdownDialog(Dialog):

    def __init__(self, master, word, title=None) :
        self.word = word
        tkSimpleDialog.Dialog.__init__(self,master, title)

    def audition(self, event):
        phonemenum = self.choose.curselection()
        try:
            phonemenum = string.atoi(phonemenum[0])
        except ValueError: pass
        phoneme = self.choose.get(phonemenum)
        self.example["text"] = pronunciation[phoneme]


    def addphoneme(self):
        # extraphoneme = self.phonemechoice.get()
        phonemenum = self.choose.curselection()
        try:
            phonemenum = string.atoi(phonemenum[0])
        except ValueError: pass
        extraphoneme = self.choose.get(phonemenum)
        self.phoneticised.insert(END, extraphoneme)
        self.phoneticised.update_idletasks()
        stressvar = self.stress.get()
        if (extraphoneme[0] in ['A','E','I','O','U']):
            self.phoneticised.insert(END, stressvar)
        self.phoneticised.insert(END, ' ')
        self.phoneticised.update_idletasks()

    def body(self, master):

        self.example = Label(master, text="Double-click on a phoneme to see pronunciation", relief=SUNKEN)
        self.example.pack(side=TOP,expand=YES, fill=X)


        Label(master, text=strings["Please breakdown the word "]+self.word, relief=RIDGE, borderwidth=2, bg="Moccasin").pack(side=TOP)
        self.phoneticised = Entry(master, width=60, bg="Moccasin")
        self.phoneticised.pack(side=BOTTOM)
        if ( os.path.exists('cmu_phoneme.dict') and os.path.exists('cmu_soundex.dict') ) :
            PHONESET = ( "AA", "AE", "AH", "AO", "AW", "AY",
                "B", "CH", "D", "DH", "EH", "ER", "EY",
                "F", "G", "HH", "IH", "IY", "JH",
                "K", "L", "M", "N", "NG", "OW", "OY", 
                "P", "R", "S", "SH", "T", "TH",
                "UH", "UW", "V", "W", "Y", "Z", "ZH"
                )
        elif ( os.path.exists('moby_phoneme.dict') and os.path.exists('moby_soundex.dict') ) :
            PHONESET = ( "aa", "ar", "a", "ai", "ah", 
                "l", "b", "ch", "d", "eh", "e", 
                "f", "g", "h", "w", "ih", "i", "ge", 
                "c", "k", "l", "m", "ng", "n", 
                "oi", "ah", "ow", "aw", "o", "oo", "ooh", 
                "p", "r", "sh", "s", "th", "th", "t", 
                "uh", "ur", "v", "w", "u", 
                "z", "zz", "er", "ach", "eu", "eu"
                )
        else :
            # message to user
            tkMessageBox.showinfo('Dictionary missing', \
            "unable to find appropriate dictionary files")
            return ""

        # self.phonemechoice = StringVar()
        # self.choose = apply(OptionMenu,(master, self.phonemechoice)+PHONESET)
        # self.choose.pack(anchor=W)
        # self.phonemechoice.set('AA')
        phframe = Frame(master)
        phscrollbar = Scrollbar(phframe, orient=VERTICAL)

        self.choose = Listbox(phframe, yscrollcommand=phscrollbar.set, height=10)
        self.choose.bind("<Double-Button-1>", self.audition)


        phscrollbar.config(command=self.choose.yview)
        phscrollbar.pack(side=RIGHT, fill=Y)
        self.choose.pack(side=LEFT)
        phframe.pack(side=LEFT)
        for phs in PHONESET :
            self.choose.insert(END,phs)
        self.choose.select_set(0)



        self.stress = StringVar()
        # Radiobutton(master, text="Consonant", variable=self.stress, value="Consonant").pack(anchor=SW)
        Radiobutton(master, text=strings["Vowel: no stress"], variable=self.stress, value="0").pack(anchor=SW)
        Radiobutton(master, text=strings["Vowel: primary stress"], variable=self.stress, value="1").pack(anchor=SW)
        Radiobutton(master, text=strings["Vowel: secondary stress"], variable=self.stress, value="2").pack(anchor=SW)
        self.stress.set("0")
        # self.stress = StringVar()
        # self.stressmenu = OptionMenu(master, self.stress, "Consonant", "0", "1", "2")
        # self.stressmenu.pack(anchor=E)
        # self.stress.set("Consonant")
        # return self.choose

        self.add = Button(master, text=strings["Click here to add selected phoneme to word"], command=self.addphoneme, bg="Moccasin")
        self.add.pack(side=BOTTOM, expand=YES, fill=X)


    def apply(self):
        self.result = string.split(self.phoneticised.get())

class singlephonemeDialog(tkSimpleDialog.Dialog):
# class breakdownDialog(Dialog):

    def __init__(self, master, title=None) :
        tkSimpleDialog.Dialog.__init__(self,master, title)



    def audition(self, event):
        phonemenum = self.choose.curselection()
        try:
            phonemenum = string.atoi(phonemenum[0])
        except ValueError: pass
        phoneme = self.choose.get(phonemenum)
        self.example["text"] = pronunciation[phoneme]


    def body(self, master):

        self.example = Label(master, text="", relief=SUNKEN)
        self.example.pack(side=TOP,expand=YES, fill=X)

        Label(master, text=strings["Please select the phoneme to enter"], relief=RIDGE, borderwidth=2, bg="Moccasin").pack(side=TOP)
        if ( os.path.exists('cmu_phoneme.dict') and os.path.exists('cmu_soundex.dict') ) :
            PHONESET = ( "AA", "AE", "AH", "AO", "AW", "AY",
                "B", "CH", "D", "DH", "EH", "ER", "EY",
                "F", "G", "HH", "IH", "IY", "JH",
                "K", "L", "M", "N", "NG", "OW", "OY", 
                "P", "R", "S", "SH", "T", "TH",
                "UH", "UW", "V", "W", "Y", "Z", "ZH"
                )
        elif ( os.path.exists('moby_phoneme.dict') and os.path.exists('moby_soundex.dict') ) :
            PHONESET = ( "aa", "ar", "a", "ai", "ah", 
                "l", "b", "ch", "d", "eh", "e", 
                "f", "g", "h", "w", "ih", "i", "ge", 
                "c", "k", "l", "m", "ng", "n", 
                "oi", "ah", "ow", "aw", "o", "oo", "ooh", 
                "p", "r", "sh", "s", "th", "th", "t", 
                "uh", "ur", "v", "w", "u", 
                "z", "zz", "er", "ach", "eu", "eu"
                )
        else :
            # message to user
            tkMessageBox.showinfo(strings["Dictionary missing"], \
            strings["unable to find appropriate dictionary files"])
            return ""

        # self.phonemechoice = StringVar()
        # self.choose = apply(OptionMenu,(master, self.phonemechoice)+PHONESET)
        # self.choose.pack(anchor=W)
        # self.phonemechoice.set('AA')
        phframe = Frame(master)
        phscrollbar = Scrollbar(phframe, orient=VERTICAL)
        self.choose = Listbox(phframe, yscrollcommand=phscrollbar.set, height=10)

        self.choose.bind("<Double-Button-1>", self.audition)

        phscrollbar.config(command=self.choose.yview)
        phscrollbar.pack(side=RIGHT, fill=Y)
        self.choose.pack(side=LEFT)
        phframe.pack(side=LEFT)
        for phs in PHONESET :
            self.choose.insert(END,phs)
        self.choose.select_set(0)


        self.stress = StringVar()
        # Radiobutton(master, text="Consonant", variable=self.stress, value="Consonant").pack(anchor=SW)
        Radiobutton(master, text=strings["Vowel: no stress"], variable=self.stress, value="0").pack(anchor=SW)
        Radiobutton(master, text=strings["Vowel: primary stress"], variable=self.stress, value="1").pack(anchor=SW)
        Radiobutton(master, text=strings["Vowel: secondary stress"], variable=self.stress, value="2").pack(anchor=SW)
        self.stress.set("0")
        # self.stress = StringVar()
        # self.stressmenu = OptionMenu(master, self.stress, "Consonant", "0", "1", "2")
        # self.stressmenu.pack(anchor=E)
        # self.stress.set("Consonant")
        # return self.choose
        

    def apply(self):

        # extraphoneme = self.phonemechoice.get()
        phonemenum = self.choose.curselection()
        try:
            phonemenum = string.atoi(phonemenum[0])
        except ValueError: pass
        extraphoneme = self.choose.get(phonemenum)
        self.result = extraphoneme
        stressvar = self.stress.get()
        if (extraphoneme[0] in ['A','E','I','O','U']):
            self.result = self.result + stressvar


class test(Frame):

    def __init__(self, parent=None):    # an extended frame
        Frame.__init__(self, parent)    # attach to upper level
        self.pack()                     # do superclass init
        self.master.title("testbreakdowngui")  # set window-manager info
        self.master.iconname("testbreakdowngui")   # label when iconified
        self.b = Button(self, text="test", command=self.testbutton, bg="Moccasin")
        self.b.pack()

    def testbutton(self) :
        t = breakdownDialog(self, word="TESTING")
        # t = singlephonemeDialog(self)
        newresult = t.result
        print "new phoneme/word :%s." % newresult

if __name__ == '__main__' : 
    t = test()
    t.mainloop()

