#!/usr/local/bin/python

# STILL TO FIX : 
#
#      - make pronunciation windows show up on top of parent windows, rather than beneath
#      - make long soundex word lists scrollable

import dbhash, string, os.path
from Tkinter import *
import tkSimpleDialog, tkMessageBox
# import soundex_b
import soundex_3
# import time
import strings
strings = strings.messages

class myDialog(tkSimpleDialog.Dialog) :

    def __init__(self, master, word, wordList, title=None):
        self.wordList = wordList
        self.word = word
        tkSimpleDialog.Dialog.__init__(self, master, title)

    def body(self, master):
        Label(master, text = strings["Multiple pronunciations found !\nfor word %s\nPlease choose one"] % self.word).pack(side=TOP)

        # frame_height = 300
        canvasfrm_width = 150
        fsb = Scrollbar(master, orient=VERTICAL, jump=1)
        canvas_frm = Canvas(master, height=100, width=150, yscrollcommand=fsb.set)

        bodyframe = Frame(canvas_frm)
        bodyframe.pack()
        canvas_frm.create_window(0,0, window = bodyframe, anchor=NW)

        self.v = StringVar()
        for eachbrokenupword in self.wordList :
            nutext = eachbrokenupword
            b = Radiobutton(bodyframe, text=nutext, variable=self.v, value=eachbrokenupword)
            b.pack(anchor=W)
        b = Radiobutton(bodyframe, text=strings["None of these words"], variable=self.v, value=None)
        b.pack(anchor=W)
        
        # canvas_frm.config(scrollregion=(0,0,canvasfrm_width,canvas_frm.winfo_height()))
        # canvas_frm.config(scrollregion=canvas_frm.bbox(ALL))
        fsb.config(command=canvas_frm.yview)
        fsb.pack(side=RIGHT, fill=Y, pady=5)
        canvas_frm.pack(expand=YES, fill=BOTH, pady=5)
        canvas_frm.config(scrollregion=(0,0,canvasfrm_width,len(self.wordList)*28))


        self.lift()
        self.update()

    def apply(self):
        self.result = self.v.get()

class mySoundexDialog(tkSimpleDialog.Dialog) :

    def __init__(self, master, word, wordList, title=None):
        self.wordList = wordList
        self.word = word
        tkSimpleDialog.Dialog.__init__(self, master, title)

    def body(self, master):
        Label(master, text = strings["Word %s not found\nSimilar words found\nPlease choose one"] % self.word).pack(side=TOP)

        # frame_height = 300
        canvasfrm_width = 150
        fsb = Scrollbar(master, orient=VERTICAL, jump=1)
        canvas_frm = Canvas(master, height=100, width=150, yscrollcommand=fsb.set)

        bodyframe = Frame(canvas_frm)
        bodyframe.pack()
        canvas_frm.create_window(0,0, window = bodyframe, anchor=NW)
        # canvas_frm.config(scrollregion=(0,0,canvasfrm_width,canvas_frm.winfo_height()))

        self.v = StringVar()
        for eachbrokenupword in self.wordList :
            nutext = eachbrokenupword
            b = Radiobutton(bodyframe, text=nutext, variable=self.v, value=eachbrokenupword)
            b.pack(anchor=W)
        b = Radiobutton(bodyframe, text=strings["None of these words"], variable=self.v, value=None)
        b.pack(anchor=W)
        
        fsb.config(command=canvas_frm.yview)
        fsb.pack(side=RIGHT, fill=Y, pady=5)
        canvas_frm.pack(expand=YES, fill=BOTH, pady=5)
        # canvas_frm.config(scrollregion=canvas_frm.bbox(ALL))
        # canvas_frm.config(scrollregion=(0,0,canvasfrm_width,bodyframe.winfo_height()))
        # canvas_frm.config(scrollregion=(0,0,canvasfrm_width,canvas_frm.winfo_vrootheight()))
        canvas_frm.config(scrollregion=(0,0,canvasfrm_width,(len(self.wordList)+1)*28))
        # canvas_frm.config(scrollregion=(0,0,canvasfrm_width,bodyframe.winfo_reqheight()))
        
        self.lift()
        self.update()

    def apply(self):
        self.result = self.v.get()


def getsoundexword(word, dict, soundict, master):
    # sxcode = soundex_b.get_soundex(word)
    sxcode = soundex_3.soundex(word)
    if soundict.has_key(sxcode): # we found something that sounds like it
        multi_check = string.split(soundict[sxcode], ";") # maybe several somethings
        d = mySoundexDialog(master, word, multi_check) # ask the user if they meant this/these word/s
        # master.wait_window(d.top)
        if d.result : # if it was one of the soundex words 
            d2 = getword(d.result, dict, master) # the word exists, find out how it is pronounced
            return d2# tell the program
        else : # the user rejected all the soundex words
            return None
    else: # it's not in the soundex dictionary
        return None

def getword(word, dict, master):
    if dict.has_key(word) : # arrr, we know this one, we thinks
        breakup_multi = string.split(dict[word], ";") # can it be pronounced more than one way ?
        if len(breakup_multi) > 1 : # yep, so it can
            # print breakup_multi
            d = myDialog(master, word, breakup_multi) # ask the user which one
            # master.wait_window(d.top)
            return d.result # tell the program
        else: # it can only be pronounced one way
            return dict[word] # this way
    else: # dictionary doesn't have the word
            return None

def getuserword(word, master):
    import breakdowngui
    t = breakdowngui.breakdownDialog(master, word)
    wd = t.result
    if wd :
        wd = string.join(wd, " ")
    return wd



def breakdowntext(starttext, master):
    if ( os.path.exists('cmu_phoneme.dict') and os.path.exists('cmu_soundex.dict') ) :
        phonemedict = 'cmu_phoneme.dict'
        soundexdict = 'cmu_soundex.dict'
    elif ( os.path.exists('moby_phoneme.dict') and os.path.exists('moby_soundex.dict') ) :
        phonemedict = 'moby_phoneme.dict'
        soundexdict = 'moby_soundex.dict'
    else :
        # message to user
        tkMessageBox.showinfo(strings['Dictionary missing'], \
            strings["unable to find appropriate dictionary files"])
        return ""

   # myphonemedict = dbhash.open('phoneme.dict', 'r')
    myphonemedict = dbhash.open(phonemedict, 'r')
    mysoundexdict = dbhash.open(soundexdict, 'r')
    transCharTable = "                                       '     -                   ABCDEFGHIJKLMNOPQRSTUVWXYZ    _ ABCDEFGHIJKLMNOPQRSTUVWXYZ               S O           S O  Y                                AAAAAAACEEEEIIIIDNOOOOOOOUUUUYDSAAAAAAACEEEEIIIIONOOOOOOOUUUUUDU"
    brokeword = []
    nutext = string.translate(starttext, transCharTable) 
    nutext = string.split(nutext)
    for eachword in nutext :
        if eachword == "_":
            brokeword.append(eachword)
        else:
            wd = getword(eachword, myphonemedict, master)
            if wd :
                brokeword.append(wd)
            else:
                wd = getsoundexword(eachword, myphonemedict, mysoundexdict, master)
                if wd :
                    brokeword.append(wd)
                else:
                    wd = getuserword(eachword, master)    # ask the user to break down the word
                    if wd :
                        brokeword.append(wd)
    # return brokeword
    myphonemedict.close()
    mysoundexdict.close()
    fullbreakdown = []
    for eachword in brokeword :
        for phoneme in string.split(eachword) :
            fullbreakdown.append(phoneme)
    return fullbreakdown

def simplifiedbreakdowntext(starttext, master):
    if ( os.path.exists('cmu_phoneme.dict') and os.path.exists('cmu_soundex.dict') ) :
        phonemedict = 'cmu_phoneme.dict'
        soundexdict = 'cmu_soundex.dict'
        # primary and secondary emphasis, MBP, FV, WQ
        significant_phonemes = [
            "AA1", "AA2", 
            "AE1", "AE2", 
            "AH1", "AH2", 
            "AO1", "AO2", 
            "AW1", "AW2", 
            "AY1", "AY2", 
            "B",
            "EH1", "EH2", 
            "ER1", "ER2", 
            "EY1", "EY2", 
            "F",
            "IH1", "IH2", 
            "IY1", "IY2", 
            "M",
            "OW1", "OW2", 
            "OY1", "OY2", 
            "P",
            "UH1", "UH2", 
            "UW1", "UW2", 
            "V", "W"
        ]
    elif ( os.path.exists('moby_phoneme.dict') and os.path.exists('moby_soundex.dict') ) :
        phonemedict = 'moby_phoneme.dict'
        soundexdict = 'moby_soundex.dict'
        significant_phonemes = []
    else :
        # message to user
        tkMessageBox.showinfo(strings['Dictionary missing'], \
            strings["unable to find appropriate dictionary files"])
        return ""

    myphonemedict = dbhash.open(phonemedict, 'r')
    mysoundexdict = dbhash.open(soundexdict, 'r')
    transCharTable = "                                       '     -                   ABCDEFGHIJKLMNOPQRSTUVWXYZ    _ ABCDEFGHIJKLMNOPQRSTUVWXYZ               S O           S O  Y                                AAAAAAACEEEEIIIIDNOOOOOOOUUUUYDSAAAAAAACEEEEIIIIONOOOOOOOUUUUUDU"
    brokeword = []
    nutext = string.translate(starttext, transCharTable)  # fix foreign accents
    nutext = string.split(nutext) # broken into words
    for eachword in nutext :
        if eachword == "_":
            brokeword.append(eachword)
        else:
            wd = getword(eachword, myphonemedict, master)
            if wd :
                brokeword.append(wd)
            else:
                wd = getsoundexword(eachword, myphonemedict, mysoundexdict, master)
                if wd :
                    brokeword.append(wd)
                else:
                    wd = getuserword(eachword, master)    # ask the user to break down the word
                    if wd :
                        brokeword.append(wd)
    # brokeword is now a list of words in phonetic format
    myphonemedict.close()
    mysoundexdict.close()
    fullbreakdown = []
    for eachword in brokeword :
        eachword = string.split(eachword)
        fullbreakdown.append(eachword[0])
        if len(eachword) > 1:
            for phoneme in eachword[1:-1] :
                if phoneme in significant_phonemes:
                    fullbreakdown.append(phoneme)
            fullbreakdown.append(eachword[-1])

    return fullbreakdown





if __name__ == "__main__" :
    root = Tk()
    # Button(root, text="Hello!").pack()
    # root.update()
    # test = """ "What! Can't you ad-lib 'this' ?", Bert said."""  #' ending single quotation mark to cope with my text editor colour syntax highlighting
    # t1 = breakdowntext(test)
    # print t1
    # root = None
    test2 = "hot dog canyon axe loch _ _ father tears in the dictionary"
    t2 = breakdowntext(test2, root)
    print t2
    t2 = simplifiedbreakdowntext(test2, root)
    print t2
