#!/usr/local/bin/python

import ConfigParser, UserDict

class pamfile(UserDict.UserDict) :

    def __init__(self, filename=None) :
        UserDict.UserDict.__init__(self)
        self.cp = ConfigParser.ConfigParser()
        if filename :
            self.filename = filename
            self.cp.read([self.filename])
            for section in self.cp.sections() :
                self.data[section] = {}
                for option in self.cp.options(section) :
                    self.data[section][option] = self.cp.get(section, option)


    def save(self, filename=None) :
        if not filename :
            # filename = './PAMELA_file.pam'
            filename = 'PAMELA_file.pam'
        f = open(filename, 'w')
        for section in self.data.keys() :
            f.write('[%s]\n' % section)
            for option in self.data[section].keys():
                if option != '__name__' :
                    f.write('%s:%s\n' % (str(option),str(self.data[section][option])))
            f.write('\n')
        f.close()


if __name__ == '__main__' : 
        # prefsfilename = './PAMELA.prf'
        prefsfilename = 'PAMELA.prf'
        prefsdata = pamfile(prefsfilename)
        print prefsdata.data